% A5_31
%% a) FKL-Verfahren mit SISO-Tool

% G=zpk([-1.2],[-6.5 -4 0],166.6)*tf([0.4 1],[5 1]);
% figure(1);bode(G);grid;
% R=tf([5 1],[0.5 1]);
% figure(2);bode(R*G);grid;
% sisotool;

%% b) Betragsoptimum
% 
G=zpk([],[-2.5 -0.1],3/4,'DisplayFormat','TimeConstants')
% Streckentyp ermitteln
T=sort(-1./pole(G),'descend')
Tsum=sum(T(2:end))     % T(1) >> Tsum  -> 1 groe Zeitkonstante
kS=dcgain(G)
% Reglerparameter berechnen
kR=1/(2*kS*Tsum)
T_R=T(1)
R=kR*tf([T_R 1],[1 0])
step(G,minreal(R*G/(1+R*G)))
%  
%% c) Kompensationsregler
% 
% G=15*tf([1 2 10],[1 46.6 572.6 827 300])
% % Voraussetzungen prfen
% pole(G)     % alle Pole links -> stabil
% zero(G)     % alle Nullstellen links -> minimalphasig
% Fw=zpk([],[-20,-25],500,'DisplayFormat','TimeConstants');
% pole(minreal(Fw/(1-Fw)))    % Mitkopplung von Fw stabil
% % Regler berechnen
% R=minreal(1/G*Fw/(1-Fw));
% step(G,minreal(R*G/(1+R*G)));
% 
%% d) WOK-Verfahren
% 
% G=tf([1 1],[1 -1]);
% sisotool(G)
% % P-Regler reicht nicht, PI-Rgler z.B. mit TR=0.5 und kR=3
